## density-fitness 1.0.3

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.15)

# set the project name
project(density-fitness VERSION 1.0.3 LANGUAGES CXX)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CMakePackageConfigHelpers)
include(Dart)
include(GenerateExportHeader)

set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers")
elseif(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

option(CCP4 "The location where ccp4 is installed" "")
if(DEFINED CCP4 AND EXISTS ${CCP4})
	set(CLIBD ${CCP4}/lib/data)
elseif(EXISTS $ENV{CCP4})
	set(CCP4 $ENV{CCP4})
	set(CLIBD ${CCP4}/lib/data)
endif()

if(EXISTS "${CCP4}")
	set(BUILD_SHARED_LIBS ON)

	list(PREPEND CMAKE_MODULE_PATH "${CCP4}/Lib")
	list(APPEND CMAKE_PREFIX_PATH ${CCP4})
	if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
		set(CMAKE_INSTALL_PREFIX ${CCP4})
	endif()
endif()

if(MSVC)
    # make msvc standards compliant...
    add_compile_options(/permissive-)

	macro(get_WIN32_WINNT version)
		if (WIN32 AND CMAKE_SYSTEM_VERSION)
			set(ver ${CMAKE_SYSTEM_VERSION})
			string(REPLACE "." "" ver ${ver})
			string(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})

			set(${version} "0x${ver}")
		endif()
	endmacro()

	get_WIN32_WINNT(ver)
	add_definitions(-D_WIN32_WINNT=${ver})

	# On Windows, do not install in the system location
	if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND NOT BUILD_FOR_CCP4)
		message(STATUS "The library and auxiliary files will be installed in $ENV{LOCALAPPDATA}/${PROJECT_NAME}")
		set(CMAKE_INSTALL_PREFIX "$ENV{LOCALAPPDATA}/${PROJECT_NAME}" CACHE PATH "..." FORCE)
	endif()
endif()

if(UNIX AND NOT APPLE)
	# On Linux, install in the $HOME/.local folder by default
	if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
		message(WARNING "The library and auxiliary files will be installed in $ENV{HOME}/.local")
		set(CMAKE_INSTALL_PREFIX "$ENV{HOME}/.local" CACHE PATH "..." FORCE)
	endif()
endif()

# Create a revision file, containing the current git version info
include(VersionString)
write_version_header()

# Optionally use mrc to create resources
find_package(Mrc)

if(MRC_FOUND)
	option(USE_RSRC "Use mrc to create resources" ON)
else()
	message(STATUS "Not using resources since mrc was not found")
endif()

if(USE_RSRC)
	set(USE_RSRC 1)

	message("Using resources compiled with ${MRC_EXECUTABLE}")
	add_compile_definitions(USE_RSRC)

	mrc_write_header(${CMAKE_BINARY_DIR}/mrsrc.hpp)
endif()

# libraries
find_package(pdb-redo 2.0.2 REQUIRED)
find_package(Boost COMPONENTS program_options REQUIRED)

add_executable(density-fitness
	${PROJECT_SOURCE_DIR}/src/density-fitness.cpp
	${density-fitness_RESOURCE})

if(USE_RSRC)
	mrc_target_resources(density-fitness ${CIFPP_SHARE_DIR}/mmcif_pdbx_v50.dic)
endif()

target_include_directories(density-fitness PRIVATE pdb-redo::pdb-redo ${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR})
target_link_libraries(density-fitness PRIVATE pdb-redo::pdb-redo Boost::program_options)

install(TARGETS ${PROJECT_NAME}
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
)

# manual

if(UNIX)
	install(FILES doc/density-fitness.1
		DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1)
endif()

if(EXISTS "${CCP4}/html")
	install(FILES doc/density-fitness.html
		DESTINATION ${CCP4}/html)
endif()

## density-fitness 1.0.0

=== debian/changelog ===
density-fitness (1.0.0-2) unstable; urgency=medium

  * [PATCH] revision.hpp: Patch to use SOURCE_DATE_EPOCH
    Closes: #978003

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 04 Jan 2021 08:20:20 +0100

density-fitness (1.0.0-1) unstable; urgency=medium

  * Initial release (Closes: #976849)

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 08 Dec 2020 15:56:25 +0100

=== debian/control ===
Source: density-fitness
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
Build-Depends: debhelper-compat (= 13),
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libcifpp-dev,
               libpdb-redo-dev,
               libzeep-dev,
               autoconf-archive,
               libgsl-dev,
               libclipper-dev,
               libnewuoa-dev,
               pkg-config
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/density-fitness
Vcs-Git: https://salsa.debian.org/med-team/density-fitness.git
Homepage: https://github.com/PDB-REDO/density-fitness
Rules-Requires-Root: no

Package: density-fitness
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libcifpp1, libpdb-redo1, libzeep5
Description: Calculates per-residue electron density scores
 The program density-fitness calculates electron density metrics,
 for main- (includes Cβ atom) and side-chain atoms of individual residues.
 .
 For this calculation, the program uses the structure model in either PDB
 or mmCIF format and the electron density from the 2mFo-DFc and mFo-DFc maps.
 If these maps are not readily available, the MTZ file and model can be used
 to calculate maps clipper. Density-fitness support both X-ray and electron
 diffraction data.
 .
 This program is essentially a reimplementation of edstats, a program
 available from the CCP4 suite. However, the output now contains only the
 RSR, SRSR and RSCC fields as in edstats with the addition of EDIAm
 and OPIA and no longer requires pre-calculated map coefficients.

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export DEST_DIR:=/usr
export LDOPTS:=$(LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --disable-revision

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, libcifpp-dev, libpdb-redo-dev
Restrictions: allow-stderr

## density-fitness 1.0.3

=== debian/changelog ===
density-fitness (1.0.3-1) unstable; urgency=medium

  * New upstream release. 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 04 Feb 2022 08:33:54 +0100

density-fitness (1.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 08 Nov 2021 11:15:58 +0100

density-fitness (1.0.0-4) unstable; urgency=medium

  * Force dependency on right libpdb-redo

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 03 Nov 2021 08:01:09 +0100

density-fitness (1.0.0-3) unstable; urgency=medium

  * Fix dependency on libzeep

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 02 Nov 2021 13:24:03 +0100

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,16 @@
 Build-Depends: debhelper-compat (= 13),
                libboost-iostreams-dev,
                libboost-program-options-dev,
-               libcifpp-dev,
-               libpdb-redo-dev,
+               libcifpp-dev (>= 2.0.0-1~),
+               libpdb-redo-dev (>= 2.0.1-3~),
                libzeep-dev,
-               autoconf-archive,
+               cmake,
                libgsl-dev,
                libclipper-dev,
                libnewuoa-dev,
+               mrc,
+               zlib1g-dev,
+               libbz2-dev,
                pkg-config
 Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/density-fitness
@@ -22,7 +25,11 @@
 
 Package: density-fitness
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libcifpp1, libpdb-redo1, libzeep5
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         libcifpp2,
+         libpdb-redo2,
+         libzeep5.1
 Description: Calculates per-residue electron density scores
  The program density-fitness calculates electron density metrics,
  for main- (includes Cβ atom) and side-chain atoms of individual residues.

=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,5 @@
 
 %:
 	dh $@
-
 override_dh_auto_configure:
-	dh_auto_configure -- --disable-revision
+	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, libcifpp-dev, libpdb-redo-dev (>= 1.0.2-3~)
Restrictions: allow-stderr

## density-fitness 1.0.8

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.15)

# set the project name
project(density-fitness VERSION 1.0.8 LANGUAGES CXX)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CMakePackageConfigHelpers)
include(Dart)
include(GenerateExportHeader)

set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers")
elseif(MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

option(CCP4 "The location where ccp4 is installed" "")

if(DEFINED CCP4 AND EXISTS ${CCP4})
	set(CLIBD ${CCP4}/lib/data)
elseif(EXISTS $ENV{CCP4})
	set(CCP4 $ENV{CCP4})
	set(CLIBD ${CCP4}/lib/data)
endif()

if(EXISTS "${CCP4}")
	set(BUILD_SHARED_LIBS ON)

	list(PREPEND CMAKE_MODULE_PATH "${CCP4}/Lib")
	list(APPEND CMAKE_PREFIX_PATH ${CCP4})

	if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
		set(CMAKE_INSTALL_PREFIX ${CCP4})
	endif()
endif()

if(MSVC)
	# make msvc standards compliant...
	add_compile_options(/permissive-)

	macro(get_WIN32_WINNT version)
		if(WIN32 AND CMAKE_SYSTEM_VERSION)
			set(ver ${CMAKE_SYSTEM_VERSION})
			string(REPLACE "." "" ver ${ver})
			string(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})

			set(${version} "0x${ver}")
		endif()
	endmacro()

	get_WIN32_WINNT(ver)
	add_definitions(-D_WIN32_WINNT=${ver})
endif()

# Create a revision file, containing the current git version info
include(VersionString)
write_version_header()

# Optionally use mrc to create resources
find_package(Mrc)

if(MRC_FOUND)
	option(USE_RSRC "Use mrc to create resources" ON)
else()
	message(STATUS "Not using resources since mrc was not found")
endif()

if(USE_RSRC)
	message("Using resources compiled with ${MRC_EXECUTABLE}")
	mrc_write_header(${PROJECT_BINARY_DIR}/mrsrc.hpp)
endif()

# libraries
if(NOT PDB_REDO_META)
	find_package(libmcfp REQUIRED)
	find_package(zeep REQUIRED)
	find_package(pdb-redo 3.0.1 REQUIRED)
endif()

add_executable(density-fitness
	${PROJECT_SOURCE_DIR}/src/density-fitness.cpp
	${PROJECT_SOURCE_DIR}/src/main.cpp)

if(USE_RSRC)
	mrc_target_resources(density-fitness ${CIFPP_SHARE_DIR}/mmcif_pdbx.dic ${CIFPP_SHARE_DIR}/mmcif_ddl.dic)
endif()

target_include_directories(density-fitness PRIVATE ${PROJECT_BINARY_DIR})
target_link_libraries(density-fitness PRIVATE pdb-redo::pdb-redo zeep::zeep libmcfp::libmcfp)

install(TARGETS ${PROJECT_NAME}
	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
)

# testing
if(ENABLE_TESTING)
	find_package(Boost REQUIRED)

	add_executable(unit-test-density-fitness
		${PROJECT_SOURCE_DIR}/test/unit-test-density-fitness.cpp
		${PROJECT_SOURCE_DIR}/src/density-fitness.cpp)

	target_include_directories(unit-test-density-fitness PRIVATE ${PROJECT_SOURCE_DIR}/src ${PROJECT_BINARY_DIR})

	target_link_libraries(unit-test-density-fitness pdb-redo::pdb-redo libmcfp::libmcfp zeep::zeep Boost::boost)

	add_test(NAME unit-test-density-fitness COMMAND $<TARGET_FILE:unit-test-density-fitness> -- ${PROJECT_SOURCE_DIR}/test)

	if(USE_RSRC)
		mrc_target_resources(unit-test-density-fitness ${CIFPP_SHARE_DIR}/mmcif_pdbx.dic ${CIFPP_SHARE_DIR}/mmcif_ddl.dic)
	endif()
endif()

# manual
if(UNIX)
	install(FILES doc/density-fitness.1
		DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1)
endif()

if(EXISTS "${CCP4}/html")
	install(FILES doc/density-fitness.html
		DESTINATION ${CCP4}/html)
endif()

=== debian/changelog ===
density-fitness (1.0.8-4) unstable; urgency=medium

  * Update pdb-redo dependency.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sat, 04 Feb 2023 09:48:33 +0100

density-fitness (1.0.8-3) unstable; urgency=medium

  * Update pdb-redo dependency.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 02 Feb 2023 19:43:33 +0100

density-fitness (1.0.8-2) unstable; urgency=medium

  * Add dependency on libcifpp-dev, libpdb-redo-dev
    in order to have the example files installed.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 04 Jan 2023 21:39:02 +0100

density-fitness (1.0.8-1) unstable; urgency=medium

  * New upstream release.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 23 Nov 2022 15:40:46 +0100

=== debian/control ===
--- 
+++ 
@@ -4,19 +4,13 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
 Build-Depends: debhelper-compat (= 13),
-               libboost-iostreams-dev,
-               libboost-program-options-dev,
-               libcifpp-dev (>= 2.0.0-1~),
-               libpdb-redo-dev (>= 2.0.1-3~),
-               libzeep-dev,
-               cmake,
-               libgsl-dev,
-               libclipper-dev,
-               libnewuoa-dev,
-               mrc,
-               zlib1g-dev,
-               libbz2-dev,
-               pkg-config
+ libcifpp-dev (>= 5.0.5-2~),
+ libpdb-redo-dev (>= 3.0.5-2~),
+ libzeep-dev,
+ libmcfp-dev,
+ zlib1g-dev,
+ cmake,
+ mrc
 Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/density-fitness
 Vcs-Git: https://salsa.debian.org/med-team/density-fitness.git
@@ -26,10 +20,7 @@
 Package: density-fitness
 Architecture: any
 Depends: ${shlibs:Depends},
-         ${misc:Depends},
-         libcifpp2,
-         libpdb-redo2,
-         libzeep5.1
+         ${misc:Depends}
 Description: Calculates per-residue electron density scores
  The program density-fitness calculates electron density metrics,
  for main- (includes Cβ atom) and side-chain atoms of individual residues.

=== debian/rules ===
--- 
+++ 
@@ -13,5 +13,3 @@
 
 %:
 	dh $@
-override_dh_auto_configure:
-	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON

## density-fitness 1.0.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 cmake_minimum_required(VERSION 3.15)
 
 # set the project name
-project(density-fitness VERSION 1.0.8 LANGUAGES CXX)
+project(density-fitness VERSION 1.0.12 LANGUAGES CXX)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -35,8 +35,7 @@
 include(CheckIncludeFiles)
 include(CheckLibraryExists)
 include(CMakePackageConfigHelpers)
-include(Dart)
-include(GenerateExportHeader)
+include(CTest)
 
 set(CXX_EXTENSIONS OFF)
 set(CMAKE_CXX_STANDARD 17)
@@ -71,6 +70,7 @@
 if(MSVC)
 	# make msvc standards compliant...
 	add_compile_options(/permissive-)
+	add_link_options(/NODEFAULTLIB:library)
 
 	macro(get_WIN32_WINNT version)
 		if(WIN32 AND CMAKE_SYSTEM_VERSION)
@@ -88,10 +88,10 @@
 
 # Create a revision file, containing the current git version info
 include(VersionString)
-write_version_header()
+write_version_header("${CMAKE_CURRENT_SOURCE_DIR}/src")
 
 # Optionally use mrc to create resources
-find_package(Mrc)
+find_package(Mrc QUIET)
 
 if(MRC_FOUND)
 	option(USE_RSRC "Use mrc to create resources" ON)
@@ -105,9 +105,15 @@
 endif()
 
 # libraries
-if(NOT PDB_REDO_META)
+if(NOT (libmcfp_FOUND OR TARGET libmcfp))
 	find_package(libmcfp REQUIRED)
+endif()
+
+if(NOT (zeep_FOUND OR TARGET zeep))
 	find_package(zeep REQUIRED)
+endif()
+
+if(NOT (pdb-redo_FOUND OR TARGET pdb-redo))
 	find_package(pdb-redo 3.0.1 REQUIRED)
 endif()
 
@@ -119,15 +125,15 @@
 	mrc_target_resources(density-fitness ${CIFPP_SHARE_DIR}/mmcif_pdbx.dic ${CIFPP_SHARE_DIR}/mmcif_ddl.dic)
 endif()
 
-target_include_directories(density-fitness PRIVATE ${PROJECT_BINARY_DIR})
-target_link_libraries(density-fitness PRIVATE pdb-redo::pdb-redo zeep::zeep libmcfp::libmcfp)
+target_include_directories(density-fitness PRIVATE pdb-redo::pdb-redo ${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR})
+target_link_libraries(density-fitness PRIVATE pdb-redo::pdb-redo libmcfp::libmcfp zeep::zeep)
 
 install(TARGETS ${PROJECT_NAME}
 	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
 )
 
 # testing
-if(ENABLE_TESTING)
+if(BUILD_TESTING)
 	find_package(Boost REQUIRED)
 
 	add_executable(unit-test-density-fitness
@@ -136,7 +142,7 @@
 
 	target_include_directories(unit-test-density-fitness PRIVATE ${PROJECT_SOURCE_DIR}/src ${PROJECT_BINARY_DIR})
 
-	target_link_libraries(unit-test-density-fitness pdb-redo::pdb-redo libmcfp::libmcfp zeep::zeep Boost::boost)
+	target_link_libraries(unit-test-density-fitness pdb-redo::pdb-redo libmcfp::libmcfp zeep::zeep Boost::headers)
 
 	add_test(NAME unit-test-density-fitness COMMAND $<TARGET_FILE:unit-test-density-fitness> -- ${PROJECT_SOURCE_DIR}/test)

=== debian/changelog ===
density-fitness (1.0.12-2) unstable; urgency=medium

  * Fix autopkgtest.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sat, 26 Oct 2024 09:50:28 +0200

density-fitness (1.0.12-1) unstable; urgency=medium

  * New upstream.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sat, 26 Oct 2024 08:48:45 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
 Build-Depends: debhelper-compat (= 13),
- libcifpp-dev (>= 5.0.5-2~),
- libpdb-redo-dev (>= 3.0.5-2~),
+ libcifpp-dev (>= 7.0.7-2~),
+ libpdb-redo-dev (>= 3.1.5-3~),
  libzeep-dev,
  libmcfp-dev,
  zlib1g-dev,

## density-fitness 1.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 cmake_minimum_required(VERSION 3.15)
 
 # set the project name
-project(density-fitness VERSION 1.0.12 LANGUAGES CXX)
+project(density-fitness VERSION 1.1.2 LANGUAGES CXX)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -38,7 +38,7 @@
 include(CTest)
 
 set(CXX_EXTENSIONS OFF)
-set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD 20)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
@@ -67,23 +67,39 @@
 	endif()
 endif()
 
+if(WIN32)
+	if(${CMAKE_SYSTEM_VERSION} GREATER_EQUAL 10) # Windows 10
+		add_definitions(-D _WIN32_WINNT=0x0A00)
+	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.3) # Windows 8.1
+		add_definitions(-D _WIN32_WINNT=0x0603)
+	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.2) # Windows 8
+		add_definitions(-D _WIN32_WINNT=0x0602)
+	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.1) # Windows 7
+		add_definitions(-D _WIN32_WINNT=0x0601)
+	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.0) # Windows Vista
+		add_definitions(-D _WIN32_WINNT=0x0600)
+	else() # Windows XP (5.1)
+		add_definitions(-D _WIN32_WINNT=0x0501)
+	endif()
+
+	# Man, this is 2024 we're living in...
+	add_definitions(-DNOMINMAX)
+
+	# We do not want to write an export file for all our symbols...
+	set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
+endif()
+
 if(MSVC)
 	# make msvc standards compliant...
-	add_compile_options(/permissive-)
+	add_compile_options(/permissive- /bigobj)
 	add_link_options(/NODEFAULTLIB:library)
 
-	macro(get_WIN32_WINNT version)
-		if(WIN32 AND CMAKE_SYSTEM_VERSION)
-			set(ver ${CMAKE_SYSTEM_VERSION})
-			string(REPLACE "." "" ver ${ver})
-			string(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})
-
-			set(${version} "0x${ver}")
-		endif()
-	endmacro()
-
-	get_WIN32_WINNT(ver)
-	add_definitions(-D_WIN32_WINNT=${ver})
+	# This is dubious...
+	if(BUILD_SHARED_LIBS)
+		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
+	else()
+		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
+	endif()
 endif()
 
 # Create a revision file, containing the current git version info
@@ -105,17 +121,9 @@
 endif()
 
 # libraries
-if(NOT (libmcfp_FOUND OR TARGET libmcfp))
-	find_package(libmcfp REQUIRED)
-endif()
-
-if(NOT (zeep_FOUND OR TARGET zeep))
-	find_package(zeep REQUIRED)
-endif()
-
-if(NOT (pdb-redo_FOUND OR TARGET pdb-redo))
-	find_package(pdb-redo 3.0.1 REQUIRED)
-endif()
+find_package(mcfp REQUIRED)
+find_package(zeep REQUIRED)
+find_package(pdb-redo 3.2.0 REQUIRED)
 
 add_executable(density-fitness
 	${PROJECT_SOURCE_DIR}/src/density-fitness.cpp
@@ -126,7 +134,7 @@
 endif()
 
 target_include_directories(density-fitness PRIVATE pdb-redo::pdb-redo ${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR})
-target_link_libraries(density-fitness PRIVATE pdb-redo::pdb-redo libmcfp::libmcfp zeep::zeep)
+target_link_libraries(density-fitness PRIVATE pdb-redo::pdb-redo mcfp::mcfp zeep::zeep)
 
 install(TARGETS ${PROJECT_NAME}
 	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
@@ -134,21 +142,7 @@
 
 # testing
 if(BUILD_TESTING)
-	find_package(Boost REQUIRED)
-
-	add_executable(unit-test-density-fitness
-		${PROJECT_SOURCE_DIR}/test/unit-test-density-fitness.cpp
-		${PROJECT_SOURCE_DIR}/src/density-fitness.cpp)
-
-	target_include_directories(unit-test-density-fitness PRIVATE ${PROJECT_SOURCE_DIR}/src ${PROJECT_BINARY_DIR})
-
-	target_link_libraries(unit-test-density-fitness pdb-redo::pdb-redo libmcfp::libmcfp zeep::zeep Boost::headers)
-
-	add_test(NAME unit-test-density-fitness COMMAND $<TARGET_FILE:unit-test-density-fitness> -- ${PROJECT_SOURCE_DIR}/test)
-
-	if(USE_RSRC)
-		mrc_target_resources(unit-test-density-fitness ${CIFPP_SHARE_DIR}/mmcif_pdbx.dic ${CIFPP_SHARE_DIR}/mmcif_ddl.dic)
-	endif()
+	add_subdirectory(test)
 endif()
 
 # manual

=== test/CMakeLists.txt ===
find_package(Catch2 3 REQUIRED)

add_executable(unit-test-density-fitness
	${PROJECT_SOURCE_DIR}/test/unit-test-density-fitness.cpp
	${PROJECT_SOURCE_DIR}/src/density-fitness.cpp)

target_include_directories(unit-test-density-fitness PRIVATE ${PROJECT_SOURCE_DIR}/src ${PROJECT_BINARY_DIR})

target_link_libraries(unit-test-density-fitness pdb-redo::pdb-redo mcfp::mcfp zeep::zeep Catch2::Catch2WithMain)

add_test(NAME unit-test-density-fitness COMMAND $<TARGET_FILE:unit-test-density-fitness> --data-dir ${PROJECT_SOURCE_DIR}/test)

if(USE_RSRC)
	mrc_target_resources(unit-test-density-fitness ${CIFPP_SHARE_DIR}/mmcif_pdbx.dic ${CIFPP_SHARE_DIR}/mmcif_ddl.dic)
endif()

=== debian/changelog ===
density-fitness (1.1.2-1) unstable; urgency=medium

  [ Nilesh Patra ]
  * Minor fix for autopkgtest

  [ Maarten L. Hekkelman ]
  * New upstream version 1.1.2

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 29 Jan 2025 10:38:06 +0100

=== debian/control ===
--- 
+++ 
@@ -10,8 +10,10 @@
  libmcfp-dev,
  zlib1g-dev,
  cmake,
+ libcatch2-dev,
+ libeigen3-dev,
  mrc
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/density-fitness
 Vcs-Git: https://salsa.debian.org/med-team/density-fitness.git
 Homepage: https://github.com/PDB-REDO/density-fitness

## density-fitness 1.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,13 +22,14 @@
 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 # SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
-cmake_minimum_required(VERSION 3.15)
+cmake_minimum_required(VERSION 3.25)
 
 # set the project name
-project(density-fitness VERSION 1.1.2 LANGUAGES CXX)
+project(density-fitness VERSION 1.1.3 LANGUAGES CXX)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
+include(FindOrFetch)
 include(GNUInstallDirs)
 include(CheckFunctionExists)
 include(CheckIncludeFile)
@@ -121,9 +122,13 @@
 endif()
 
 # libraries
-find_package(mcfp REQUIRED)
-find_package(zeep REQUIRED)
-find_package(pdb-redo 3.2.0 REQUIRED)
+find_package(nlohmann_json REQUIRED)
+
+# find_package(cifpp 7 REQUIRED)
+
+find_or_fetch_package(mcfp VERSION 1.3.5 GIT_REPOSITORY https://github.com/mhekkel/libmcfp GIT_TAG b6c62a3)
+find_or_fetch_package(cifpp VERSION 7 GIT_REPOSITORY https://github.com/PDB-REDO/libcifpp.git GIT_TAG v7.0.9 VARIABLES "CIFPP_SHARE_DIR")
+find_or_fetch_package(pdb-redo VERSION 3.2.0 GIT_REPOSITORY https://github.com/PDB-REDO/libpdb-redo.git GIT_TAG v3.2.1)
 
 add_executable(density-fitness
 	${PROJECT_SOURCE_DIR}/src/density-fitness.cpp
@@ -134,7 +139,7 @@
 endif()
 
 target_include_directories(density-fitness PRIVATE pdb-redo::pdb-redo ${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR})
-target_link_libraries(density-fitness PRIVATE pdb-redo::pdb-redo mcfp::mcfp zeep::zeep)
+target_link_libraries(density-fitness PRIVATE pdb-redo::pdb-redo mcfp::mcfp nlohmann_json::nlohmann_json)
 
 install(TARGETS ${PROJECT_NAME}
 	RUNTIME DESTINATION ${BIN_INSTALL_DIR}

=== debian/changelog ===
density-fitness (1.1.3-1) unstable; urgency=medium

  * New upstream version 1.1.3

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 01 Apr 2025 10:44:49 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
  libcifpp-dev (>= 7.0.7-2~),
  libpdb-redo-dev (>= 3.1.5-3~),
- libzeep-dev,
+ nlohmann-json3-dev,
  libmcfp-dev,
  zlib1g-dev,
  cmake,

## density-fitness 1.1.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 cmake_minimum_required(VERSION 3.25)
 
 # set the project name
-project(density-fitness VERSION 1.1.3 LANGUAGES CXX)
+project(density-fitness VERSION 1.1.4 LANGUAGES CXX)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -124,11 +124,9 @@
 # libraries
 find_package(nlohmann_json REQUIRED)
 
-# find_package(cifpp 7 REQUIRED)
-
 find_or_fetch_package(mcfp VERSION 1.3.5 GIT_REPOSITORY https://github.com/mhekkel/libmcfp GIT_TAG b6c62a3)
 find_or_fetch_package(cifpp VERSION 7 GIT_REPOSITORY https://github.com/PDB-REDO/libcifpp.git GIT_TAG v7.0.9 VARIABLES "CIFPP_SHARE_DIR")
-find_or_fetch_package(pdb-redo VERSION 3.2.0 GIT_REPOSITORY https://github.com/PDB-REDO/libpdb-redo.git GIT_TAG v3.2.1)
+find_or_fetch_package(pdb-redo VERSION 3.3.0 GIT_REPOSITORY https://github.com/PDB-REDO/libpdb-redo.git GIT_TAG v3.3.0)
 
 add_executable(density-fitness
 	${PROJECT_SOURCE_DIR}/src/density-fitness.cpp

=== test/CMakeLists.txt ===
# Makefile for tests

find_or_fetch_package(Catch2 VERSION 3 GIT_REPOSITORY https://github.com/catchorg/Catch2.git GIT_TAG v3.8.0)

add_executable(unit-test-density-fitness
	${PROJECT_SOURCE_DIR}/test/unit-test-density-fitness.cpp
	${PROJECT_SOURCE_DIR}/src/density-fitness.cpp)

target_include_directories(unit-test-density-fitness PRIVATE ${PROJECT_SOURCE_DIR}/src ${PROJECT_BINARY_DIR})

target_link_libraries(unit-test-density-fitness pdb-redo::pdb-redo mcfp::mcfp nlohmann_json::nlohmann_json Catch2::Catch2WithMain)

add_test(NAME unit-test-density-fitness COMMAND $<TARGET_FILE:unit-test-density-fitness> --data-dir ${PROJECT_SOURCE_DIR}/test)

if(USE_RSRC)
	mrc_target_resources(unit-test-density-fitness ${CIFPP_SHARE_DIR}/mmcif_pdbx.dic ${CIFPP_SHARE_DIR}/mmcif_ddl.dic)
endif()

=== debian/changelog ===
density-fitness (1.1.4-2) unstable; urgency=medium

  * less strict testing on i386

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 07 Sep 2025 19:38:08 +0200

density-fitness (1.1.4-1) unstable; urgency=medium

  * New upstream version 1.1.4

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 02 Apr 2025 11:03:10 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
 Build-Depends: debhelper-compat (= 13),
  libcifpp-dev (>= 7.0.7-2~),
- libpdb-redo-dev (>= 3.1.5-3~),
+ libpdb-redo-dev (>= 3.3.0-1~),
  nlohmann-json3-dev,
  libmcfp-dev,
  zlib1g-dev,

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/density-fitness-$1\.tar\.gz/ \
  https://github.com/PDB-REDO/density-fitness/tags .*/v?(\d\S+)\.tar\.gz

## density-fitness 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,17 +25,12 @@
 cmake_minimum_required(VERSION 3.25)
 
 # set the project name
-project(density-fitness VERSION 1.1.4 LANGUAGES CXX)
+project(density-fitness VERSION 1.2.0 LANGUAGES CXX)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 include(FindOrFetch)
 include(GNUInstallDirs)
-include(CheckFunctionExists)
-include(CheckIncludeFile)
-include(CheckIncludeFiles)
-include(CheckLibraryExists)
-include(CMakePackageConfigHelpers)
 include(CTest)
 
 set(CXX_EXTENSIONS OFF)
@@ -108,16 +103,16 @@
 write_version_header("${CMAKE_CURRENT_SOURCE_DIR}/src")
 
 # Optionally use mrc to create resources
-find_package(Mrc QUIET)
+find_package(mrc QUIET)
 
 if(MRC_FOUND)
 	option(USE_RSRC "Use mrc to create resources" ON)
 else()
-	message(STATUS "Not using resources since mrc was not found")
+	message(STATUS "density-fitness: Not using resources since mrc was not found")
 endif()
 
 if(USE_RSRC)
-	message("Using resources compiled with ${MRC_EXECUTABLE}")
+	message(STATUS "density-fitness: Using resources compiled with ${MRC_EXECUTABLE}")
 	mrc_write_header(${PROJECT_BINARY_DIR}/mrsrc.hpp)
 endif()
 
@@ -125,7 +120,7 @@
 find_package(nlohmann_json REQUIRED)
 
 find_or_fetch_package(mcfp VERSION 1.3.5 GIT_REPOSITORY https://github.com/mhekkel/libmcfp GIT_TAG b6c62a3)
-find_or_fetch_package(cifpp VERSION 7 GIT_REPOSITORY https://github.com/PDB-REDO/libcifpp.git GIT_TAG v7.0.9 VARIABLES "CIFPP_SHARE_DIR")
+find_or_fetch_package(cifpp VERSION 9 GIT_REPOSITORY https://github.com/PDB-REDO/libcifpp.git GIT_TAG v9.0.5 VARIABLES "CIFPP_SHARE_DIR")
 find_or_fetch_package(pdb-redo VERSION 3.3.0 GIT_REPOSITORY https://github.com/PDB-REDO/libpdb-redo.git GIT_TAG v3.3.0)
 
 add_executable(density-fitness

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Makefile for tests
 
-find_or_fetch_package(Catch2 VERSION 3 GIT_REPOSITORY https://github.com/catchorg/Catch2.git GIT_TAG v3.8.0)
+find_or_fetch_package(Catch2 VERSION 3 GIT_REPOSITORY https://github.com/catchorg/Catch2.git GIT_TAG v3.4.0)
 
 add_executable(unit-test-density-fitness
 	${PROJECT_SOURCE_DIR}/test/unit-test-density-fitness.cpp

=== debian/changelog ===
density-fitness (1.2.0-2) unstable; urgency=medium

  * Team upload.
  * Fix clean target.
  * Drop "Rules-Requires-Root: no" (default).
  * Drop "Priority: optional" (default).
  * Update standards-version.
  * Simplify salsa-ci.yml.

 -- Santiago Vila <sanvila@debian.org>  Tue, 03 Feb 2026 09:10:00 +0100

density-fitness (1.2.0-1) unstable; urgency=medium

  * New upstream version 1.2.0

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 20 Nov 2025 11:32:49 +0100

density-fitness (1.1.4-3) unstable; urgency=medium

  * update dependencies

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 20 Nov 2025 11:20:01 +0100

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,19 @@
 Source: density-fitness
 Section: science
-Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
 Build-Depends: debhelper-compat (= 13),
- libcifpp-dev (>= 7.0.7-2~),
- libpdb-redo-dev (>= 3.3.0-1~),
+ libpdb-redo-dev (>= 3.3.1-1~),
  nlohmann-json3-dev,
  libmcfp-dev,
- zlib1g-dev,
  cmake,
  libcatch2-dev,
  libeigen3-dev,
  mrc
-Standards-Version: 4.6.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/density-fitness
 Vcs-Git: https://salsa.debian.org/med-team/density-fitness.git
 Homepage: https://github.com/PDB-REDO/density-fitness
-Rules-Requires-Root: no
 
 Package: density-fitness
 Architecture: any
